## V.0.9.0 RC
### Бэк
1. Огранизация прозрачного REST API через интерфейс fox\externalCallable - позволяет с минимальными затратами но при этом со всеми необходимыми проверками организовать доступ к нужным сущностям.
2. Поддержка сторонних модулей с возможностью установки нескольких инстансов одного модуля (если поддерживается модулем).
3. Аутентификация пользователей — как с помощью встроенных средств так и с помощью внешних источников oAuth (на данный момент реализована поддержка Gitlab, Gitea, Yandex, VK).
4. Авторизация пользователей — с помощью встроенной системы контроля доступа, основанной на ролях производится гибкая проверка наличия у пользователя прав доступа. Списки ролей пользователя проверяются как бэком при выполнении вызовов REST API, так и фронтом — для этого после аутентификации передается список прав доступа текущего пользователя.
5. Возможность выполнения запросов без авторизации, если такое необходимо. Например для реализации Вебхуки.
6. Встроенные миграции БД на основе описания структуры класса.
7. Базовый класс для выполнения стандартных функции работы с БД (запись, чтение, поиск, удаление) на основе которого можно быстро создавать сущности.
8. Поддержка memcached как для встроенных объектов так и для пользовательских для быстрого доступа к часто используемым данным
9. Хранилище конфигурации для каждого модуля в БД (с кэшем) так и глобальной в окружении контейнера.
10. Встроенный функционал регистрации пользователей по приглашениям с возможность автоматического добавления в группы как для предоставления доступа так и для организации в логические группы («списки»).
11. Встроенный функционал кодов подтверждения действий как для встроенных функций (восстановление пароля, подтверждение почты итд) так и для пользовательских модулей.
12. Поддержка управления S3-совместимым хранилищем (создание букетов, удаление данных итд).
13. Возможность добавления любых других объектных хранилищ на основе типового интерфейса.
14. Хранение файлов (вложений электронной почты, вложений в servicedesk, шаблонов и результатов отчетов итд) в S3-совместимом объектном хранилище
15. Встроенная поддержка форматов OpenDocument ODS и ODT для автоматизированного формирования документов (отчеты, счета, акты итд)
16. Встроенная поддержка Fox Converter для экспорта документов в любом офисном формате.
17. Встроенная поддержка на уровне базового класса обмена данными в формате JSON с возможность контроля видимости отдельных свойств и создания виртуальных свойств.
18. Встроенный eMail клиент, поддерживающий одновременную работу как на получение так и на отправку писем в том чисте с вложениями с нескольких учетных записей по протоколам IMAP и SMTP (с авторизацией и без).
19. Хранение метаданных модулей (например, последняя синхронизация итд) во встроенном хранилище с кешированием.
20. Поддержка получения и формирования данных в формате Prometheus
21. Встроенный REST API Client для связи со сторонними системами.
22. Встроенные интерфейсы stringExportable && stringImportable для автоматической конвертации объектов в строку и обратно (например время в unixTime или ISO).
23. Встроенный модуль шифрования критиченых данных (например, паролей) а так же формирования хэшей на основе индивидуального мастер-пароля.
24. Система формирования уникальных идентификаторов в формате 1000-0000-00 с контрольной суммой для формирования реестра документов, инвентаризации и других объектов. Например для организации глобального поиска (в будущих релизах) и штрих-кодов.
25. Встроенный cron, позволяющий запускать периодические процессы модулей параллельно с ограничением по максимальному времени выполнения и с возможностью блокировки повторного запуска, пока не завершится прошлый процесс отдельно для каждой задачи.
26. Поддержка нескольких языков, например для отправки уведомлений на электронную почту или мессенджеры. Список языков может различаться для Chimera Core и дополнительных модулей.
27. Логирование всех действий пользователей.

### Фронт
1. Встроенные методы взаимодействия по REST как с собственным бэком, так и с другими службами.
2. Формирование визуального базового интерфейса пользователя на нескольких языках
3. Базовые функции администрирования системы
4. Авторизациия, регистрации пользователей. Контроль сессий
5. Встроенная библиотека Fox UI для формирования меню, диалогов, кнопок, форм включая формы автоматической генерации паролей и автозаполнения.
6. Библиотека проверки прав доступа для контроля за отображением элементов интерфейса.
7. Возможность кастомизации интерфейса в помощью создания собственных цветовых тем и изображений.
8. Использование FontAwesome 5 для формирования интерфейсов, так же возможно добавление собственных шрифтов с иконками.